uses crt, zfs, go32;
{$I386_intel}   {Uses Intel assembler syntax}

var
  i:longint;                         {counter}

  pack1, pack2, pack3 :pZIP;
  tmpDir  :pMEMDir;
  tmpPack :pZIP;
  ff :ZFSfile;                       {file handler}

  pp :pointer;                       {buffer}

  timer :longint absolute $40:$6c;   {timer clock}
  time1,time2:longint;
  time:real;


begin
  WriteLN('# Free memory before initialize ', MEMAVAIL);

  pack1:=OpenZIP ('TEST.ZIP');   {Opens the ZIP file}
  if ZFSResult<>0 then HALT;

  WriteLN('# Free memory afte initialize ',MEMAVAIL);
  WriteLN;
  WriteLN('Press a key to continue');
  readkey;

  {Shows all the files inside the openned ZIP files}
  tmpPack:=FirstZIP;
  REPEAT
    ClrScr;
    TextBackground(Blue);
    WritelN('Num.':4,'  ','Name':15,'  ','Position':8,'  ','size':6,'  ','real size':11);
    TextBackground(Black);
    i:=0;
    tmpDir:=tmpPack^.FirstMemDir;
    REPEAT
      WritelN(i+1:4,'  ',tmpdir^.Obj.Nom:15,'  ',tmpdir^.obj.Pos:8,'  ',tmpdir^.obj.size:6,'  ',tmpdir^.obj.usize:11);

      inc(i,1);
      if (i mod 23)=0 then
       begin
         readkey;
         ClrSCR;
         TextBackground(Blue);
         WritelN('Num.':4,'  ','Name':15,'  ','Position':8,'  ','size':6,'  ','real size':11);
         TextBackground(Black);
       end;
      tmpDir:=tmpDir^.Next;
    UNTIL tmpDir=NIL;

    readkey;
    tmpPack:=tmpPack^.Next;
  UNTIL tmpPack=NIL;

  Assign(ff, 'DIABOLO.RAW');  {We open a file}
  If ZFSResult<>0 then HALT;

  if NOT ff.InZIP then             {If it's on disk we display a message}
   begin
     WriteLN('File found outside a ZIP file');
     readkey;
   end;

  {ff.usize tells us the uncompressed size of the open file}
  Getmem(pp, ff.usize);      {allocates the needed memory for the buffer}

  time1:=timer;
  BlockRead(ff, pp^, ff.usize);   {Decompressed the file into the buffer}
  time2:=timer;


  asm mov ax, 13h; int 10h; end;  {Sets the VGA 320x200x256 standard mode}
  for i:=0 to 255 do              {Sets a GrayScaled palette}
   begin
     port[$3c8]:=i;
     port[$3c9]:=i;
     port[$3c9]:=i;
     port[$3c9]:=i;
   end;
  asm                          {Flips the buffer into the VGA Ram}
    push es                        {Saves ES selector}
    mov  es, DosMemSelector
    mov  edi, $a0000               {VGA Ram addres}
    mov  esi, pp
    mov  ecx, 64000/4
    rep  movsd                     {copy the buffer}
    pop  es                        {Restore the ES selector}
  end;
  readkey;
  asm mov ax, 03h; int 10h; end;   {puts the Text mode}


  FreeMem(pp, ff.usize);      {Frees the buffer memory}

  Close(ff);                  {Closes the open file}


{  CloseZIP(pack1);
  CloseZIP(pack2);
  CloseZIP(pack3);} {They will be closed automatically at the end}

  {Calculate the time spended in the decompression}
  time:=time2-time1;
  time:=time/18.2;
  WriteLN('DECOMPRESSION TIME : ',time :8:2);
end.
